SET PROCEDURE TO LIBRARY

********************
FUNCTION FileOpen()
********************
PARAMETERS sDBFName, lOpenFile
PRIVATE sWorkArea, nWorkArea

nWorkArea = WorkArea(sDBFName)

IF nWorkArea = 0
	nWorkArea = NextWorkArea()
	SELECT(nWorkArea)
	USE &sDBFName INDEX &sDBFName
	SET INDEX TO &sDBFName
	INC arDBFInUse[nWorkArea]       
ELSE
	SELECT(nWorkArea)   
	IF lOpenFile
		INC arDBFInUse[nWorkArea]           
	ENDIF
ENDIF   

RETURN(.T.)
************************
FUNCTION FileOpenIndex()
************************
PARAMETERS sDBFName, lOpenFile
PRIVATE sWorkArea, nWorkArea

nWorkArea = WorkArea(sDBFName)

IF nWorkArea = 0
	nWorkArea = NextWorkArea()
	SELECT(nWorkArea)
	USE &sDBFName 
	INC arDBFInUse[nWorkArea]       
ELSE
	SELECT(nWorkArea)   
	IF lOpenFile
		INC arDBFInUse[nWorkArea]           
	ENDIF
ENDIF   

RETURN(.T.)
********************
FUNCTION FileClose()
********************
PARAMETERS sDBFName
PRIVATE nWorkArea, nSelect

nWorkArea = WorkArea(sDBFName)
IF nWorkArea <> 0
	
	DEC arDBFInUse[nWorkArea]
	
	IF arDBFInUse[nWorkArea] = 0
		nSelect = SELECT(nWorkArea)
		CLOSE
		SELECT(nSelect)
	ENDIF

ENDIF

RETURN(.F.)
***********************
FUNCTION NextWorkArea()
***********************
PRIVATE nWorkArea, nCount

nWorkArea = 0
FOR nCount = 1 to 26
	IF nCount = 13
		LOOP
	ENDIF
	IF arDBFInUse[nCount] = 0
		nWorkArea = nCount
		EXIT
	ENDIF
NEXT

IF nWorkArea = 0
	BEEP
	WARNING(csError,csWorkArea,387)
ENDIF

RETURN nWorkArea
*******************
FUNCTION WorkArea()
*******************
PARAMETERS sDBFName
PRIVATE nWorkArea, nCount, nSelect

nSelect = SELECT(1)
nWorkArea = 0
nCount = 1

FOR nCount = 1 to 26
	IF nCount = 13          && MEMORY
		LOOP
	ENDIF
	SELECT(nCount)
	IF TrimIt(DBF()) = TrimIt(sDBFName)
		nWorkArea = nCount
		EXIT
	ENDIF
NEXT

SELECT(nSelect)

RETURN nWorkArea

FUNCTION TrimIt
PARAMETERS sName
PRIVATE nPosition

sName = UPPER(sName)

nPosition = RAT('\',SName)
IF nPosition > 0
	sName = RIGHT(sName,LEN(sName) - nPosition)
ENDIF

nPosition = AT('.',sName)
IF nPosition > 0
	sName = LEFT(sName, nPosition -1)
ENDIF

RETURN sName

//////////////////////////////////////////////////////////////
FUNCTION DrawBox()
PARAMETERS A,B,C,D,Efecto

A=PIXROWS()*(A+1)-4
B=PIXCOLS()*(B+1)
C=PIXROWS()*(C+1)-4
D=PIXCOLS()*(D+1)

htmColor = SAYVIDEO()
DO CASE
   CASE PCOUNT()>4 .AND. Efecto = 1          // NORNAL HUNDIDO
        SET SAY VIDEO TO 127
        @ POINT A,B TO C+1,D+1
        @ POINT A+1,B+1 TO C,D
        SET SAY VIDEO TO 120
        @ POINT A,B TO C,D

   CASE PCOUNT()>4 .AND. Efecto = 2  // NORMAL REALZADO
        SET SAY VIDEO TO 120
        @ POINT A,B TO C,D
        SET SAY VIDEO TO 127
        @ POINT A-1,B-1 TO C,D
        SET SAY VIDEO TO 120
        @ POINT A,D TO C,D
        @ POINT C,B TO C,D

   CASE PCOUNT()>4 .AND. Efecto = 3		// REALZADO
        SET SAY VIDEO TO 127
        @ POINT A,B TO C,D
        SET SAY VIDEO TO 120
        @ POINT A-1,B-1 TO C,D
        SET SAY VIDEO TO 119
        @ POINT A-1,B-1 TO C,B-1
        @ POINT A-1,B-1 TO A-1,D

   CASE PCOUNT()>4 .AND. Efecto = 4 // HUNDIDO
        SET SAY VIDEO TO 120
        @ POINT A,B TO C,D
        SET SAY VIDEO TO 127
        @ POINT A-1,B-1 TO C,D
        SET SAY VIDEO TO 119
        @ POINT A-1,B-1 TO C,B-1
        @ POINT A-1,B-1 TO A-1,D

ENDCASE
SET SAY VIDEO TO htmColor
RETURN(.T.)

********************************************
FUNCTION DrawLine()
********************************************
PARAMETERS A,B,D

A=PIXROWS()*(A+1)-4
B=PIXCOLS()*(B+1)-5
C=A
D=PIXCOLS()*(D+1)-5

DbfColor=SAYVIDEO()

SET SAY VIDEO TO 120
DRAW LINE POINT FROM A,B TO C,D

SET SAY VIDEO TO 127
DRAW LINE POINT FROM A+1,B+1 TO C+1,D+1

SET SAY VIDEO TO DbfColor
RETURN(.T.)