*:
*: MODI.INC - Incluse file for MODI.PRG
*:
*: Copyright (c) 1992 Computer Associates International Inc.
*:
*: Edit Date  By                  Reason
*:---------------------------------------------------------------------------
*:            Dan Luciano         New Program for 2.0
*: 06/02/92   Sidney Wang         Change all string constants to numeric 
*:                                resource ID. All strings will be loaded   
*:                                from dbFast.exe string table.
*: 02/03/93   Robert Bishop       Include all constant strings in .prg file
*:                                into .inc file.  String table no longer being
*:                                used.
*:---------------------------------------------------------------------------
*:

*----------------------------
*: Event defines
#define eKybd                1          && keyboard event
#define eMenu                2          && menu event
#define eWindow              3          && window selected
#define eClose               5          && close box selected
#define eButton              6          && button selected
#define eScroll              7          && scroll bar selected
#define eMClick              10         && mouse click
#define eWMove               12         && move window
#define eWSize               13         && resize window
*----------------------------
*: ID return defines                    && for READDIALOG function
#define IdCancel             0
#define IdDelete             1
#define IDADDTOOLS           2
#define IdOk                 3
#define IDOTHER              4

*----------------------------
*: Action defines
#define aExit                1
#define aSave                2
#define aCloseWindow         3
#define aSelect              4
#define aRejectField         5
#define aAcceptField         6
#define aDone                7
#define aAdd                 8
#define aInsert              9
#define aDelete              10
#define aNext                11
#define aCancel              12
#define aUp                  13
#define aDown                14

*----------------------------
*: buttons
#define bOk            'Ok'
#define bClose         'Close'
#define bCancel        'Cancel'
#define bFCancel       'Cancel '
#define bEdit          'Edit'
#define bAdd           'Add'
#define bDone          'Done'
#define bInsert        'Insert'
#define bDelete        'Delete'
#define bNext          'Next'
#define bSaveAs        'Save As'

*----------------------------
*: keys
#define kCtrlA               1
#define kCtrlC               3
#define kCtrlD               4
#define kCtrlE               5
#define kCtrlF               6
#define kCtrlG               7
#define kCtrlH               8
#define kCtrlI               9
#define kCtrlJ               10
#define kCtrlK               11
#define kCtrlL               12
#define kCtrlM               13
#define kCtrlN               14
#define kCtrlO               15
#define kCtrlP               16
#define kCtrlQ               17
#define kCtrlR               18
#define kCtrlS               19
#define kCtrlT               20
#define kCtrlU               21
#define kCtrlV               22
#define kCtrlW               23
#define kCtrlX               24
#define kCtrlY               25
#define kCtrlZ               26

#define kEnter               13
#define kEsc                 27
#define kCtrlEnter           513
#define kUp                  529
#define kPgUp                530
#define kDown                535
#define kPgDn                536
#define kCtrlHome            539
#define kCtrlUp              540
#define kCtrlEnd             545
#define kCtrlDn              546
#define kF1                  550
#define kF12                 561
#define kCtrlF12             1561

*----------------------------
*: Numeric constants
#define cnOkButton           1
#define cnCancelButton       2
#define cnCloseButton        4
#define cnDeleteButton       8
#define cnAcceptButton       256
#define cnRejectButton       512

#define cnHide               16

#define cnMaxFields          1024
#define cnMaxBuffer          250
#define cnMaxFieldSize		32767

#define cnNoSort             256
#define cnValidOn2Click      512

*----------------------------
*: String constants
#define csProgramTitle        'Data File Structure Editor'
#define csVersion             'Version  2.00'
#define csCopyright           'Copyright  1992'
#define csCompany             'Computer Associates International, Inc.'

#define csMemory              'Memory:'
#define csDiskSpace           'Disk Space:'
#define csKBFree              'KB Free'

#define csNew                 '<new>'
#define csCreate              'New '
#define csModify              'Modify '
#define csDataFile            'Data File'
#define csStructure           'Structure'
#define csFileName            'File Name'

#define csField               'Field'
#define csFields              'Fields'
#define csName                'Name'
#define csLength              'Length'
#define csDecimals            'Decimal'
#define csType                'Type'
#define csTypes               'Char;Num;Date;Logic;Memo;Pict'

#define csTooManyFields       'Too Many Fields'
#define csMaxAlready          'Maximum Number Of Fields For This File'
#define csFileExistsErr       'File Exists Error'
#define csInvalidChars        'Invalid Characters in Field Name'
#define csAlreadyExists       ' already exists'
#define csDuplicate           'Duplicate Entry'

#define csFODataFiles         'Data Files,*.DBF'

#define csFileAlready         'File Already Exists'
#define csNewDataFile         'New Data File: '
#define csEditDataFile        'Edit Data File: '
#define csSaveChanges         'Save Changes to this File?'
#define csReallyDelete        'Really Delete This Field?'

#define csTooManyFlds         'Too Many Fields'
#define csMsgMaxFields        'There Are 1024 Fields in this File'
#define csRecTooLarge         'Record Size Error'
#define csGT3999Bytes         'Record Size Over 32766 Bytes'
#define csOverWriteFile       'Overwrite Existing File '
#define csFileNotExist        'File Does Not Exist'

#define csNoOperation         'No Operation - Make a Menu Choice'
#define csErrDupFldName       'Duplicate or Invalid Field Name'
#define csErrMaxFldLenN       'Max Field Length is 254 or 16 for Numeric'
#define csErrMaxDecLen        'Maximum Decimals is 15'
#define csParamError          'Parameter Error'
#define csErrFileName         'File Name Error'
#define csErrBadChars         'Illegal Characters in File Name'
#define csDupFileName         'Duplicate File Name'
#define csInvalidChar         'Invalid Character'
#define csErrParameter        'Parameter Error'
#define csDecTwoLess          'Decimal must be 2 less than the field length' 
#define csNotDatabase         '   Not a Database File   '
#define csFieldCError         'Field Count Error'
#define csNumFields           'Number of fields = 0'
#define csNumFieldsCol        '  Number Fields: '
#define csRecSize             '  Record Size: '
#define csEditField           'Editing Field:'
#define csEnterFName          'Please enter a field name'
#define csFirstChara          'First character of a field name must be a letter'
#define csNotNumber           'Length entered, is not numeric'
#define csDecReq              'A decimal is required an must be 2 less than the length'
#define csDecNotNum           'Decimal entered, is not numeric'
#define csDataStru            'Data File Structure'
#define csStruChange          'Are you sure you want to discard the changes?'
#define csDataDBF             'Data File Structure, *.DBF'
#define csNewFile             'New File Name'
#define csSaveChange          'Save changes to '
#define csAllDeleted          'All fields deleted! Are you done?'
#define csEraseFile           'All fields deleted! Ok to erase data file?'
#define csDataFileDBF         'Data File,*.DBF'
#define csAddField            'Adding Field:'
#define csInsert              'Inserting Field:'
#define csDosError            'Dos Error='
#define csdBFastError         ' dBFast Error='
#define csLineNum             ' line='
#define csProcName            ' procname='
#define csDosFileErr          'DOS file error'

*----------------------------
*: Internal Window Names
#define wModi                'Modi'
#define wNewFile             'New File Name'
*:------------------------------------------------------------------------
*: errmsgs.inc - Include file for errors in dBFast application designer   
*:               The strings for these errors are define in errmsgs.rc
*:               which is part of the dbfast exe
*:                                                                        
*: Copyright (c) 1992 Computer Associates International Inc.              
*:                                                                        
*: Edit Date  By                  Reason                                  
*:------------------------------------------------------------------------
*:            Dan Luciano         New Program for 2.0                     
*:------------------------------------------------------------------------
#define    cesNoProcName       'Must enter Procedure Name for this When Selected type'
#define    cesOptionNotFound   'Option Not Found'
#define    cesNoRunDirect      'This Program Cannot be Run Directly'
#define    cesFileExistsErr    'File Exists Error'
#define    cesAlreadyExists    ' already exists'
#define    cesDuplicate        'Duplicate Entry'
#define    cesNoCopySame       'Cannot Copy From Same Dictionary'
#define    cesTooManyFlds      'Too Many Fields'
#define    cesMaxFields        'There Are 1024 Fields in this File'
#define    cesRecTooLarge      'Record Size Error'
#define    cesGT3999Bytes      'Record Size Over 32766 Bytes'
#define    cesDuplicateField   'Duplicate Field Name'
#define    cesInvalidChar      'Invalid Character'
#define    cesFileNotFound     'File Not Found'
#define    cesNoLibFile        'The library file DEFAULT.MIB was not found'
#define    cesFileError        'File Error'
#define    cesPos2Record       'Error positioning to record: '
#define    cesVersionError     'Program Version Error'
#define    cesV200OrHigher     'requires dBFast v2.00 or higher'
#define    cesInvalidFormName  'Invalid form name'
#define    cesNoDBFInDict      'No Databases in dictionary'
#define    cesCharFldLen       'Field Length is 1 to 254 for Character Type'
#define    cesDateFldLen       'Field Length is 8 for Date Type'
#define    cesLogFldLen        'Field Length is 1 for Logical Type'
#define    cesMemoFldLen       'Field Length is 10 for Memo Type'
#define    cesNumFldLen        'Field Length is 1 to 17 for Numeric Type'
#define    cesPicFldLen        'Field Length is 10 for Picture Type'
#define    cesMaxDecFldLen     'Maximum Decimal Length is 15'
#define    cesNoDecAllowed     'Decimal Length is not allow for this field type'


